<?php
// +-----------------------------------------------------------------------+
// |  Copyright (c) CoCoSoft 2005-10                                  |
// +-----------------------------------------------------------------------+
// | This file is free software; you can redistribute it and/or modify     |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation; either version 2 of the License, or     |
// | (at your option) any later version.                                   |
// | This file is distributed in the hope that it will be useful           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of        |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          |
// | GNU General Public License for more details.                          |
// +-----------------------------------------------------------------------+
// | Author: CoCoSoft
// +-----------------------------------------------------------------------+
//
include("localvars.php");
$debug = false;   //  set true for debug
try {
    /*** connect to SQLite database ***/
    $dbh = new PDO($sarkdb);
    /*** set the error reporting attribute ***/
    $dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
    $cluster=array();
    $sql = "SELECT * FROM Cluster";
    foreach ($dbh->query($sql) as $row) {
    	$cluster[$row['pkey']] = "OPEN";
    }
    $sql = "SELECT * FROM dateSeg";
    foreach ($dbh->query($sql) as $row) {
    	$match = false;
    	if ($row['month'] != "*" ) {
			if ($row['month'] != strtolower(date("M", time())) ) {
				if  ($debug) {
					syslog(LOG_WARNING,"timer ". $row['pkey'] . " MONTH FAILS " . $row['month'] . " " . strtolower(date("M", time())) );
				}
               	continue;
			}
			$match = true;
			if  ($debug) {
				syslog(LOG_WARNING, "timer ". $row['pkey'] . " MONTH MATCHED " . $row['month'] );
			}
        }
        if ($row['dayofweek'] != "*" ) {
    	   if ($row['dayofweek'] != strtolower(date("D", time())) ) {
				if  ($debug) {
					syslog(LOG_WARNING, "timer ". $row['pkey'] .  " DAY FAILS " . $row['dayofweek']);
				}
               	continue;
           }
           $match = true;
			if  ($debug) {
				syslog(LOG_WARNING, "timer ". $row['pkey'] . " DAY MATCHED " . $row['dayofweek'] );
			}
        }
        if ($row['datemonth'] != "*" ) {
    	   if ($row['datemonth'] != date( "j", time() ) ) {
				if ($debug) {
					syslog(LOG_WARNING, "timer ". $row['pkey'] .  " DATE FAILS " . $row['datemonth']);
				}
               	continue;
			}
			$match = true;
			if ($debug) {
				syslog(LOG_WARNING, "timer ". $row['pkey'] .   " DATE " . $row['datemonth'] );
			}
        }
        if ($row['timespan'] == "*" ) {
           if ($match == true) {
				if ($debug) {
                syslog(LOG_WARNING, "timer ". $row['pkey'] .   " TIMESPAN = * BUT MATCHED  - WE'RE CLOSED " . $row['timespan'] );
				}
                $cluster[$row['cluster']] = "CLOSED";
               	continue;
           }
           else {
				if ($debug) {
					syslog(LOG_WARNING, "timer ". $row['pkey'] .    " ALL STARS  - WE'RE OPEN " . $row['cluster']);
				}
                continue;
           }
        }
        if (preg_match(" /^(\d\d):(\d\d)-(\d\d):(\d\d)$/",$row['timespan'],$matches)) {
			$tstart =  $matches[1] . $matches[2];
			if ($debug) {
				syslog(LOG_WARNING, "timer ". $row['pkey'] .  " T-START $tstart");
			}
			$tend =  $matches[3] . $matches[4];
			if ($debug) {
				syslog(LOG_WARNING, "timer ". $row['pkey'] .  " T-END $tend");
			}
			if ($tstart > $tend) {           
				if ( $tstart <  date( "Hi", time()) || $tend > date( "Hi", time()) ) {
					if ($debug) {
						syslog(LOG_WARNING, "timer ". $row['pkey'] . " DATE - " . date( "Hi", time()) );
						syslog(LOG_WARNING, "timer ". $row['pkey'] . " Invert TIMESPAN MATCHED  - WE'RE CLOSED " . $row['cluster'] );
					}
					$cluster[$row['cluster']] = "CLOSED";
					continue;               
				}
			}
			if ( $tstart <  date( "Hi", time()) && $tend > date( "Hi", time()) ) { 
				if ($debug) {        
					syslog(LOG_WARNING, "timer ". $row['pkey'] . " DATE - " . date( "Hi", time()) );
					syslog(LOG_WARNING, "timer ". $row['pkey'] . " TIMESPAN MATCHED  - WE'RE CLOSED " . $row['cluster'] );
				}
        		$cluster[$row['cluster']] = "CLOSED";
                continue;
			}
        }
        if ($debug) { 
			syslog(LOG_WARNING, "timer ". $row['pkey'] . "NO TIMESPAN MATCH FOUND" . $row['pkey'] );
		}
    }
    foreach ($cluster as $k=>$v) {
    
		$dboclo = $dbh->query("select oclo from Cluster WHERE pkey='" . $k . "'")->fetch();
		if ($dboclo['oclo'] == $v) {
			continue;
		}

    	$sql="UPDATE Cluster SET oclo=\"$v\" WHERE pkey='" . $k . "'";
        $dbh->exec($sql);
    }
    /*** close the database connection ***/
    $dbh = null;

}
catch(PDOException $e)
    {
    echo $e->getMessage();
    }
?>
