#!/usr/bin/perl

#----------------------------------------------------------------------
# heading     : Telephony
# description : IVR Menus
# navigation  : 4000 4816
#
# Copyright (c) selintra.com         2005-6
#
#----------------------------------------------------------------------
#----------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#
# Technical support for this program is available from Selintra Ltd
# Please visit our web site www.selintra.com/ for details.
#----------------------------------------------------------------------


use lib '/opt/sark/perl/modules';

use strict;
use CGI ':all';
use CGI::Carp qw(fatalsToBrowser);

use sark::SarkSubs;

sub showInitial ($$);
sub commit ($);
sub createMenu ($);
sub performCreateMenu ($);
sub linesIn ($);
sub performLinesIn ($);
sub performDelete ($);


BEGIN
{
    # Clear PATH and related environment variables so that calls to
    # external programs do not cause results to be tainted. See
    # "perlsec" manual page for details.

    $ENV {'PATH'} = '';
    $ENV {'SHELL'} = '/bin/bash';
    delete $ENV {'ENV'};
}

#esmith::util::setRealToEffective ();
$< = $>;
$( = $);

$CGI::POST_MAX=1024 * 100;  # max 100K posts
$CGI::DISABLE_UPLOADS = 1;  # no uploads

my $editicon = "<img src=\"/sark-common/edit.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkedittext')]}\">";
my $yesicon = "<img src=\"/sark-common/connected.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarktinfotext')]}\">";
my $noicon = "<img src=\"/sark-common/actions/no.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkoffline')]}\" >";
my $warnicon = "<img src=\"/sark-common/warning.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkwarntext')]}\" >";
my $infoicon = "<img src=\"/sark-common/info.png\" border=0 >";
my $greenicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkremotetext')]}\" >";
my $activeicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkactivetext')]}\" >";
my $monicon = "<img src=\"/sark-common/actions/apply.png\" border=0 title = \"@{[SarkSubs::tt_display('Sarkmontext')]}\" >";
my $trashicon = "<img src=\"/sark-common/edittrash.png\" border=0 onclick=\"return confirmOK('Delete this Object - Confirm?')\" title = \"@{[SarkSubs::tt_display('Sarkdeletetext')]}\" >";

my %ivrmenu;
my %hashScrnVars;
my @Verrors;
my $gonogo = 0;
my $cfwd;
my %hashVarDefaults = (
        "alert0" 	=> undef,
        "alert1" 	=> undef,
        "alert2" 	=> undef,
        "alert3" 	=> undef,
        "alert4" 	=> undef,
        "alert5" 	=> undef,
        "alert6" 	=> undef,
        "alert7" 	=> undef,
        "alert8" 	=> undef,
        "alert9" 	=> undef,
        "alert10" 	=> undef,
        "alert11" 	=> undef,
        "cluster"	=> "default",
        "greetnum"  	=> undef,
        "option0"	=> undef,
        "option1"	=> undef,
        "option2"	=> undef,
        "option3"	=> undef,
        "option4"	=> undef,
        "option5"	=> undef,
        "option6"	=> undef,
        "option7"	=> undef,
        "option8"	=> undef,
        "option9"	=> undef,
        "option10" 	=> undef,
        "option11" 	=> undef,
        "routeclass0"	=> 0,
        "routeclass1"	=> 0,
        "routeclass2"	=> 0,
        "routeclass3"	=> 0,
        "routeclass4"	=> 0,
        "routeclass5"	=> 0,
        "routeclass6"	=> 0,
        "routeclass7"	=> 0,
        "routeclass8"	=> 0,
        "routeclass9"	=> 0,
        "routeclass10" 	=> 0,
        "routeclass11" 	=> 0,
        "pkey"		=> undef,
        "tag0"		=> undef,
        "tag1"		=> undef,
        "tag2"		=> undef,
        "tag3"		=> undef,
        "tag4"		=> undef,
        "tag5"		=> undef,
        "tag6"		=> undef,
        "tag7"		=> undef,
        "tag8"		=> undef,
        "tag9"          => undef,
        "tag10" 	=> undef,
        "tag11" 	=> undef,
        "timeout"	=> undef,
        "timeoutrouteclass"	=> 0,
        "listenforext" => undef,
	);
my %hashVarErrors;
my %hashVarOutBuf = (
        "alert0" 	=> undef,
        "alert1" 	=> undef,
        "alert2" 	=> undef,
        "alert3" 	=> undef,
        "alert4" 	=> undef,
        "alert5" 	=> undef,
        "alert6" 	=> undef,
        "alert7" 	=> undef,
        "alert8" 	=> undef,
        "alert9" 	=> undef,
        "alert10" 	=> undef,
        "alert11" 	=> undef,
        "cluster"	=> undef,
        "greetnum"  	=> undef,
        "option0"	=> undef,
        "option1"	=> undef,
        "option2"	=> undef,
        "option3"	=> undef,
        "option4"	=> undef,
        "option5"	=> undef,
        "option6"	=> undef,
        "option7"	=> undef,
        "option8"	=> undef,
        "option9"	=> undef,
        "option10" 	=> undef,
        "option11" 	=> undef,
	"routeclass0"	=> undef,
        "routeclass1"	=> undef,
        "routeclass2"	=> undef,
        "routeclass3"	=> undef,
        "routeclass"	=> undef,
        "routeclass5"	=> undef,
        "routeclass6"	=> undef,
        "routeclass7"	=> undef,
        "routeclass8"	=> undef,
        "routeclass9"	=> undef,
        "routeclass10" 	=> undef,
        "routeclass11" 	=> undef,
        "pkey"		=> undef,
        "tag0"		=> undef,
        "tag1"		=> undef,
        "tag2"		=> undef,
        "tag3"		=> undef,
        "tag4"		=> undef,
        "tag5"		=> undef,
        "tag6"		=> undef,
        "tag7"		=> undef,
        "tag8"		=> undef,
        "tag9"          => undef,
        "tag10" 	=> undef,
        "tag11" 	=> undef,
        "timeout"	=> undef,
        "timeoutrouteclass"	=> undef,
        "listenforext" => undef,
        );
my %hashVarUpdBuf = ();
my %hashVarRegexs = (
    	"AADEFAULT" => qr/(.*)/,

        );
my %hashColorDefaults = %hashVarDefaults;
while ( my $tk = each %hashColorDefaults ) {
        $hashColorDefaults{$tk} = 'black';
}

my $pages = 1 ;
my $page = 1;
my $epages = 2;
my $epage = 1;

#
#
#

my $q = new CGI;

my %params = $q->Vars;
#
#  Retrieve the page number
#
for my $key ( keys %params ) {
       if ( $key =~ /^page(\d{1,}).x$/ ) {
       	  $page=$1;
          showInitial ($q, '');
          exit(0);
       }
       if ( $key =~ /^epage(\d{1,}).x$/ ) {
       	  $epage=$1;
          linesIn ($q);
          exit(0);
       }
}

if ($q->param ('new.x') ) {
	createMenu ($q);
}
elsif ($q->param ('delete.x') )  {
    performDelete ($q);
}
elsif ($q->param ('phase1.x') ) {
	performCreateMenu ($q);
}
elsif ($q->param ('state') eq "linesIn") {
    linesIn ($q);
}
elsif ($q->param ('upsave.x') ) {
    performLinesIn ($q);
}
elsif ($q->param ('initcommit.x') ) {
        commit ($q);
}
elsif ($q->param ('newcommit.x') ) {
        performCreateMenu ($q);
}
elsif ($q->param ('commit.x') ) {
    performLinesIn ($q);
}
#elsif ($q->param ('undo.x'))
#{
#    SarkSubs::SQLiteUndo();
#    $q->delete_all();
#    showInitial ($q,"Undo Processing complete");
#}
elsif (! grep (/^state$/, $q->param)) {
    showInitial ($q, '');
}

elsif ($q->param ('cancel.x') ) {
    showInitial ($q, '');
}

else {
    die "STATE ERROR!! ";
}
exit (0);

sub showInitial ($$)
{
    my $exists = ();
    my ($q, $msg) = @_;
    my $dbh = SarkSubs::SQLiteConnect();
    my @Menu = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM ivrmenu" ));
    my $commit = SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'");
    SarkSubs::sark_header ($q);
    my $numlines = @Menu;
    my $remainder = $numlines % 12;
    $pages = int($numlines / 12);
    if ($remainder) {
    	$pages++;
    }
    my $linelow = (($page-1) * 12);
    my $linehigh = $linelow + 12;
    print h1( SarkSubs::tt_display('Sarksystemh11').($msg || 'IVR Menus') );
    print '<hr class="hr" />';

    print '<div class="buttons">';


    SarkSubs::sark_button_new();
    SarkSubs::sark_button_commit("initcommit", $commit);
#    if (SarkSubs::SQLiteCheckUndo) {
#        SarkSubs::sark_button_undo();
#    }
    print '</div>';


    print '<div>';


    unless (@Menu) {
        print '<span style="color:red;font-weight:bold">'.SarkSubs::tt_display('Sarkivrmsg1').'</span>';
        print '</div>';
        SarkSubs::sark_footer($q);
        SarkSubs::SQLiteDisconnect($dbh);
        exit(0);
    }
    print $q->table ({border => 1, cellspacing => 1, cellpadding => 4});

    print $q->Tr (
        	$q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('ivrname')),
                $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('cluster')),
                $q->th({class=>"srk-border"}, SarkSubs::aHeaderFor('greeting')),
                $q->th({class=>"srk-border"}, ''),
                $q->th({class=>"srk-border"}, '')
                );

    my $rowcolor = 0x01;
    my $i = $linelow;
    while ($i<$linehigh && $i <= $#Menu) {
#        foreach (@IPphone)
#        {
	my $pkey  = $Menu[$i];
    	%ivrmenu = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM ivrmenu WHERE pkey = '$pkey'");
    	print $q->Tr ({-class => "d".$rowcolor},
               $q->td({class=>"srk-border"}, $pkey),
               $q->td({class=>"srk-border"}, $ivrmenu{cluster}),
               $q->td({class=>"srk-border"}, $ivrmenu{greetnum}),
               $q->td({class=>"srk-border"},
               		$q->a ({href => $q->url (-absolute => 1)
                        . "?state=linesIn&change=yes&pkey=$pkey"},
			$editicon )),
               $q->td({class=>"srk-border"},
                        $q->a ({href => $q->url (-absolute => 1)
                        . "?state=linesIn&delete=yes&pkey=$pkey"},
			$trashicon )));
    	$rowcolor = $rowcolor ^ 1;
        $i++;
    }
    print $q->end_table;
    SarkSubs::printpages($pages, $page);
    print '</div>';

    SarkSubs::sark_footer($q);
    SarkSubs::SQLiteDisconnect($dbh);
}

sub commit ($)
{
    SarkSubs::sysCommit($q);
    showInitial ($q, "<font color = red>@{[SarkSubs::tt_display('Sarksystemmsg1')]}</font color = red><font color = black>");
}

sub createMenu ($)
{

    my $desc;
    my @GreetOpts = ();
    my $menuflag = 0;

    my $dbh = SarkSubs::SQLiteConnect();
    my @IVROpts =  sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM ivrmenu"));
    my @QueueOpts = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Queue"));
    my @CustomOpts = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Appl"));
    my @SpeedOpts = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM speed"));
    my @ExtOpts = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM IPphone"));
    my @Vmails;
    	foreach (@ExtOpts) {
    	push (@Vmails,"*".$_)
    }
    my @Clusters = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Cluster"));
    my @Greetingfiles = `/bin/ls /var/lib/asterisk/sounds | /bin/grep usergreeting`;
    my @Greeting;
    foreach (@Greetingfiles) {
        if ($_ =~ /^usergreeting(\d{1,4})\.\w+$/) {
		push (@Greeting, $1);
        }
    }

    SarkSubs::sark_header ($q);
    print h1( SarkSubs::tt_display('Sarksystemh11')."Create a new IVR" );
     print '<hr class="hr" />';
    if (@Verrors) {
	SarkSubs::sark_error(\@Verrors);
    }
    print '<div class="buttons">';
    	SarkSubs::sark_button_cancel();
    	SarkSubs::sark_button_save("phase1");
    	SarkSubs::sark_button_commit( "newcommit", SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'") );
    print "</div>";

    print '<div>';
    print << 'NOTES';
        <div class="notes">
        <h4>New IVR</h4>
        <p class=\"last\">
        Fill out the IVR details and then use edit to set up the new IVR decision tree.
        <br/><strong><i>N.B.</i></strong> You won't be able to create an IVR without first creating the greeting
        it will need.  Do this at any phone using<br/><br/> <i> *60*{greeting number} </i>
        </p></div>
NOTES

    print SarkSubs::aLabelFor('ivrname');
    print $q->textfield (
		-name    => 'pkey',
                -size     => 20,
                -default  => $hashScrnVars{pkey});
    print SarkSubs::aLabelFor('greeting');
    print $q->popup_menu (
		-name    => 'greetnum',
                -values  => [@Greeting]);
        print SarkSubs::aLabelFor('cluster');
    print $q->popup_menu (
		-name    => 'cluster',
                -default => 'default',
                -values  => [@Clusters]);
    print SarkSubs::aLabelFor("listenforext");            
    print $q->popup_menu (
				-name    => 'listenforext',
                -values  => ["NO","YES"]);

    print '</div>';
    SarkSubs::sark_footer($q);
    SarkSubs::SQLiteDisconnect($dbh);

}


sub performCreateMenu ($)
{
	my ($q) = shift;
        %hashScrnVars = $q->Vars;
        #   call subs to set the routeclass
        my $key=0;
        while ($key < 12) {
        	if  ($hashScrnVars{"option$key"}) {
        		$hashScrnVars{"routeclass$key"} = SarkSubs::routeClass($hashScrnVars{"option$key"});
                }
                $key++;
        }
        if ($hashScrnVars{timeout}) {
        	$hashScrnVars{timeoutrouteclass} = SarkSubs::routeClass($hashScrnVars{timeout});
        }
        my $dbh = SarkSubs::SQLiteConnect();
        my %hashRecordColumns = SarkSubs::SQLiteGetHashCols($dbh, 'ivrmenu');
        SarkSubs::SQLiteDisconnect($dbh);
        $gonogo = SarkSubs::validateTuple(\%hashScrnVars, \%hashRecordColumns, \%hashVarRegexs,
    			\%hashVarOutBuf, \%hashColorDefaults,
                        \@Verrors);
	unless ($gonogo) {
#
#		Set defaults
#
        	while ( my ($key, $value) = each %hashVarDefaults ) {
                	unless ( $hashVarOutBuf{$key} ) {
                        	if ($hashVarDefaults{$key}) {
                        		$hashVarOutBuf{$key} = $hashVarDefaults{$key};
                                }
                        }
                }
#
#		Create record
#
        	my $dbh = SarkSubs::SQLiteConnect();
        	SarkSubs::newTuple( \%hashVarOutBuf, "ivrmenu", $dbh);
                SarkSubs::SQLiteDisconnect($dbh);
       		if ( $hashScrnVars{'newcommit.x'} ) {
    			SarkSubs::sysCommit($q);
    		}
                showInitial ($q,"Entry Created!");
    	}
        else {
        	createMenu ($q);
        }
        return 0;
}

sub linesIn ($)
{
    my ($q) = shift;


#
#  check browser (IE doesn't work good with fancybox)
#
#   if ($ENV{HTTP_USER_AGENT} =~ /(MSIE)/ ) {
#        linesInMSIE($q);
#   }
#   else {
   	linesInOthers($q);
#   }
}


sub linesInOthers ($)
{
    my ($q) = shift;
    %hashScrnVars = $q->Vars ;
    my $name     = $q->param ('name')   || '';
    my $delete   = $q->param ('delete');
    my $change   = $q->param ('change');
    my $pkey     = $q->param ('pkey');
    if ($delete eq 'yes') {
        performDelete($q);
    	return 0;
    }

    my $dbh = SarkSubs::SQLiteConnect();
    my $commit = SarkSubs::SQLiteGet($dbh, "SELECT MYCOMMIT FROM globals where pkey = 'global'");
    %ivrmenu = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM ivrmenu  WHERE pkey = '$pkey'");
    my @IVROpts =  sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM ivrmenu"));
    my @QueueOpts = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Queue"));
    my @CustomOpts = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Appl"));
    my @SpeedOpts = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM speed"));
    my @ExtOpts = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM IPphone"));
    my @Trunks = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM lineIO"));
    my @Vmails;
    foreach (@ExtOpts) {
    	push (@Vmails,"*".$_)
    }
    my @Clusters = sort (SarkSubs::SQLiteGetKeys($dbh, "SELECT pkey FROM Cluster"));
    my @Greetingfiles = `/bin/ls /var/lib/asterisk/sounds | /bin/grep usergreeting`;
    my @Greeting;
    foreach (@Greetingfiles) {
        if ($_ =~ /^usergreeting(\d{1,4})\.\w+$/) {
		push (@Greeting, $1);
        }
    }

    my $xref;
    my $tref;
    foreach (@Trunks) {
        my %rec = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM lineIO WHERE pkey = '$_'");
        if ( $rec{openroute} eq $pkey || $rec{closeroute} eq $pkey ) {
                $tref .= "Trunk $_ references this IVR<br/>";
        }
    }
    if ($tref) {
    	$xref .= $tref;
        $tref = "";
    }
    else {
    	$xref .= "No Trunks reference this IVR<br/>";
    }
    foreach (@SpeedOpts) {
        my %rec = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM speed WHERE pkey = '$_'");
        if ( $rec{outcome} =~ $pkey ) {
                /^(\d{1,4})/;
                $tref .= "Callgroup $1 references the IVR<br/>";
        }
    }
    if ($tref) {
    	$xref .= $tref;
        $tref = "";
    }
    else {
    	$xref .= "No Callgroups reference this IVR<br/>";
    }
    foreach (@CustomOpts) {
        my %rec = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM Appl WHERE pkey = '$_'");
        if ( $rec{extcode} =~ $pkey ) {
                $tref .= "Custom App $_ contains a reference to this IVR<br/>";
        }
    }
    if ($tref) {
    	$xref .= $tref;
        $tref = "";
    }
    else {
    	$xref .= "No CustomApps reference this IVR<br/>";
    }
    foreach (@IVROpts) {
        my %rec = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM ivrmenu WHERE pkey = '$_'");
        if ($rec{timeout} eq $pkey ) {
                $tref .= "IVR Timeout $_ references this IVR<br/>";
        }
        else {
                for ( my $i=0; $i <= 11; $i++ ) {
                        if  ($rec{"option".$i} eq $pkey) {
                                $tref .=  "IVR $_ references this IVR<br/>";
                                last;
                        }
                }
        }
    }
    if ($tref) {
    	$xref .= $tref;
        $tref = "";
    }
    else {
    	$xref .= "No IVRs reference this IVR<br/>";
    }

    SarkSubs::sark_header ($q);
    print h1( SarkSubs::tt_display('Sarksystemh11')."Modify IVR $pkey" );
    print '<hr class="hr" />';
    if (@Verrors) {
	SarkSubs::sark_error(\@Verrors);
    }
    print '<div class="buttons">';
    	SarkSubs::sark_button_cancel();
    	SarkSubs::sark_button_save("upsave");
    	SarkSubs::sark_button_commit( "commit", $commit);
    print '</div>';

    print '<div>';

#

    print '<div style="overflow:hidden;" id="pagetabs" class="ui-tabs-hide" >';
    print "\n";
    print '<ul>'."\n";
    print '<li><a href="#general">General</a></li>'."\n";    
    print '<li><a href="#keys" >KEYS</a></li>'."\n";
    print '<li><a href="#xref" >XREF</a></li>'."\n";
    print '</ul>'."\n";

#
#   TAB XREF table
#
    print '<div id="xref" class="ui-tabs-hide">';
    print "\n";

    print '<span style="color: rgb(0, 0, 0); font-weight:bold; font-size:small; ">Cross References to this IVR</span><br />';
    print $q->br;
    print "$xref";
    print $q->br;
    print '</div>';
#
#       TAB DIVEND
#

#
#   TAB general
#
    print '<div id="general" class="ui-tabs-hide">';


    print SarkSubs::aLabelFor('greeting');
    print $q->popup_menu (
		-name    => 'greetnum',
                -values  => [@Greeting],
                -default => $ivrmenu{greeting});
    print SarkSubs::aLabelFor('cluster');
    print $q->popup_menu (
		-name    => 'cluster',
                -values  => [@Clusters],
		-default => $ivrmenu{cluster});
    print SarkSubs::aLabelFor("keytime");
    if ($ivrmenu{timeout} =~  /^\*/) {
                my $escape = '\\'.$ivrmenu{timeout};
        	$ivrmenu{timeout} = $escape;
    }

    print $q->popup_menu (
		-name    => "timeout",
                -values  => ['None', 'Operator', 'Hangup',
			    optgroup (-name => "IVR MENUS",
				       	-values => [@IVROpts]),
			     optgroup (-name => "QUEUES",
					-values => [@QueueOpts]),
			     optgroup (-name => "EXTENSIONS",
					-values => [@ExtOpts]),
			     optgroup (-name => "CALL GROUPS",
					-values => [@SpeedOpts]),
			     optgroup (-name => "DISA",
					-values => ['DISA']),
			     optgroup (-name => "GET VOICEMAIL",
					-values => ["Retrieve Voicemail"]),
                             optgroup (-name => "LEAVE VOICEMAIL",
					-values => [@Vmails]),
			     optgroup (-name => "CUSTOM APPS",
					-values => [@CustomOpts])],
                -default => $ivrmenu{timeout} || 'Hangup');
    print SarkSubs::aLabelFor("listenforext");            
    print $q->popup_menu (
				-name    => 'listenforext',
                -values  => ["NO","YES"],
				-default => $ivrmenu{listenforext});               
    print '</div>';
#
#       TAB DIVEND
#
#    print $q->br;
#    print $q->br;

	print '<div id="keys" class="ui-tabs-hide">';
    print "\n";

    my @tableoffkey = (qw /  1-OFF.jpg 2-OFF.jpg 3-OFF.jpg 4-OFF.jpg 5-OFF.jpg 6-OFF.jpg 7-OFF.jpg 8-OFF.jpg 9-OFF.jpg star-OFF.jpg 0-OFF.jpg hash-OFF.jpg /);
    my @tableonkey = (qw /  1-on.jpg 2-on.jpg 3-on.jpg 4-on.jpg 5-on.jpg 6-on.jpg 7-on.jpg 8-on.jpg 9-on.jpg star-on.jpg 0-on.jpg hash-on.jpg /);
    my @tabnavkey = (qw / 1 2 3 4 5 6 7 8 9 10 0 11 /);
    my $key=0;
    my $limit = 12;
    print "\n";
    print '<div ><table >';

    while ($key < $limit) {
    	if ($key == 0 || $key == 3 || $key == 6 || $key == 9 ) {
        	print '<tr>';
        }
        
        my $opName = "option".$tabnavkey[$key];
        my $title = $ivrmenu{$opName} || $tabnavkey[$key];
        if ($ivrmenu{$opName} =~  /None/) {
        	print '<td><a href="#key' . $tabnavkey[$key] .
        		'" id="inline"><img src="../sark-common/keys/' . $tableonkey[$key] .
                	'" border=0 title = "' . $title . '"></a></td>';
        }
        else {
        	print '<td><a href="#key' . $tabnavkey[$key] .
        		'" id="inline"><img src="../sark-common/keys/' . $tableoffkey[$key] .
                	'" border=0 title = "' . $title . '"></a></td>';
        }
    	if ($key == 2 || $key == 5 || $key == 8 || $key == 11 )  {
        	print '</tr>';
        }
        print "\n";
    	$key++;
    }
    print '</table></div>';

    my @printkey = (qw / 0 1 2 3 4 5 6 7 8 9 * # /);
    my $key=0;
    my $limit = 12;
    while ($key < $limit) {

    print "\n\n";
    print '<div style="display:none"><div id="key'.$key.'">';

    my $opName = "option".$key;
    print "\n";

    print '<br/><span style="color: rgb(0, 0, 0); font-weight:bold;font-size:small; ">KEY' . $printkey[$key] . '</span>';
    print '<br/><span style="color: rgb(0, 0, 0); font-weight:bold;font-size:small; ">Action on Keypress</span>';
    print $q->br;
    print $q->br;
    print "\n";
    my $opName = "option".$key;
    if ($ivrmenu{$opName} =~  /^\*/) {
                my $escape = '\\'.$ivrmenu{$opName};
        	$ivrmenu{$opName} = $escape;
	}
    print $q->popup_menu (
		-name    => $opName,
                -default => $ivrmenu{$opName},
                -values  => ['None', 'Operator', 'Hangup',
			     optgroup (-name => "IVR MENUS",
				       	-values => [@IVROpts]),
			     optgroup (-name => "QUEUES",
					-values => [@QueueOpts]),
			     optgroup (-name => "EXTENSIONS",
					-values => [@ExtOpts]),
			     optgroup (-name => "CALL GROUPS",
					-values => [@SpeedOpts]),
			     optgroup (-name => "DISA",
					-values => ['DISA']),
			     optgroup (-name => "GET VOICEMAIL",
					-values => ["Retrieve Voicemail"]),
                             optgroup (-name => "LEAVE VOICEMAIL",
					-values => [@Vmails]),
			     optgroup (-name => "CUSTOM APPS",
					-values => [@CustomOpts])]);

    print "\n";
    print $q->br;
    print '<br/><span style="color: rgb(0, 0, 0); font-weight:bold;font-size:small; ">Tag entry</span>';
    print $q->br;
    print "\n";
    	print $q->textfield (
                -name     => "tag$key",
                -override => 1,
                -default  => $ivrmenu{"tag$key"},
                -size     => 22);
    print "\n";
    print $q->br;
    print '<br/><span style="color: rgb(0, 0, 0); font-weight:bold;font-size:small; ">Alert Info</span>';
    print $q->br;
    print "\n";
    	print $q->textfield (
                -name     => "alert$key",
                -override => 1,
                -default  => $ivrmenu{"alert$key"},
                -size     => 22);

    print '</div></div>';
    $key++;
    }

#
#  end of TABS DIV
#
   print '</div>';
   print '</div>';
   print $q->hidden (
                    -name     => 'pkey',
                    -override => 1,
                    -default  => $pkey);
    SarkSubs::sark_footer($q);
    SarkSubs::SQLiteDisconnect($dbh);
}


sub performLinesIn ($)
{
    my ($q) = shift;
    my $response;
    my %hashScrnVars = $q->Vars ;
    #   call subs to set the routeclass
    my $key=0;
    while ($key < 12) {
    		if ($hashScrnVars{"option$key"}) {
        		$hashScrnVars{"routeclass$key"} = SarkSubs::routeClass($hashScrnVars{"option$key"});
                }
                $key++;
    }
    if ($hashScrnVars{timeout}) {
    	$hashScrnVars{timeoutrouteclass} = SarkSubs::routeClass($hashScrnVars{timeout});
    }
    my $dbh = SarkSubs::SQLiteConnect();
    %ivrmenu = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM ivrmenu WHERE pkey = '$hashScrnVars{pkey}'");
    $gonogo = SarkSubs::validateTuple(\%hashScrnVars, \%ivrmenu, \%hashVarRegexs,
    			\%hashVarUpdBuf, \%hashColorDefaults,
                        \@Verrors);
    unless ( $gonogo ) {
    		SarkSubs::updateTuple (\%hashVarUpdBuf, \%ivrmenu, "ivrmenu", $dbh);
    }
    SarkSubs::SQLiteDisconnect($dbh);
    if ( $gonogo ) {
    		linesIn($q);
    	   	return 0;
    }
    if ($q->param('commit.x')) {
        	SarkSubs::sysCommit($q);
                $response = "Committed!";
    }
    showInitial ($q,$response);
    return 0;
}

sub performDelete ($)
{
    my ($q) = shift;
    my $pkey = $q->param ('pkey');
    my $dbh = SarkSubs::SQLiteConnect();
    SarkSubs::SQLiteDo($dbh, "UPDATE globals SET MYCOMMIT='YES' WHERE pkey='global'");
    SarkSubs::SQLiteDelete($dbh,"DELETE FROM ivrmenu where pkey='$pkey'");
    SarkSubs::SQLiteCommit($dbh);
    SarkSubs::SQLiteDisconnect($dbh);
    showInitial ($q, "<font color = red>Successfully deleted IVR $pkey</font color = red><font color = black>");
}

